find_package(Git REQUIRED QUIET)

function(generate_version_header)
  execute_process(
    COMMAND ${GIT_EXECUTABLE} log -n1 --pretty=format:%h
    OUTPUT_VARIABLE GIT_HASH
  )

  execute_process(
    COMMAND ${GIT_EXECUTABLE} status -suno
    OUTPUT_VARIABLE GIT_STATUS
  )

  if(NOT GIT_STATUS STREQUAL "")
    set(GIT_MODIFIED "M")
  endif()

  set(SION_GIT_VERSION "${GIT_HASH}${GIT_MODIFIED}")

  configure_file(
    ${ARGV}
  )
endfunction()

if(CMAKE_SCRIPT_MODE_FILE)
  include("${CMAKE_CURRENT_LIST_DIR}/Version.cmake")
  math(EXPR M "${CMAKE_ARGC} - 2")
  math(EXPR N "${CMAKE_ARGC} - 1")
  generate_version_header(
    "${CMAKE_ARGV${M}}"
    "${CMAKE_ARGV${N}}"
  )
endif()
