#!/bin/bash

set -e

DIR=$(dirname "$0")
. "${DIR}/version.sh"

rm -r www/sionlib || true
./make_dist_wwwall.sh www "${SION_VERSION}"
(
  cd www/sionlib/ && \
  cmake -B build -DCMAKE_INSTALL_PREFIX=$(pwd)/install && \
  cmake --build build && \
  cmake --install build && \
  cd build && \
  ctest --output-on-failure
)
(
  cd www/sionlib && \
  cmake -S test -B build-test -DSIONlib_ROOT=$(pwd)/install && \
  cmake --build build-test && \
  cd build-test && \
  ctest --output-on-failure
)
