#!/bin/bash

set -e

DIR=$(dirname "$0")
. "${DIR}/version.sh"

rm -r www/sionlib || true
./make_dist_wwwall.sh www "${SION_VERSION}"
(
  cd www/sionlib/ && \
  cmake -B build -DCMAKE_INSTALL_PREFIX=$(pwd)/install && \
  cmake --build build && \
  cmake --install build
)
./get_symbols_replacement.pl ./www/sionlib/install/lib* ./symbol_replacements.dat

rm -r www/sionlib || true
./make_dist_wwwall.sh www "${SION_VERSIONL}" lib
(
  cd www/sionlib/ && \
  cmake -B build -DCMAKE_INSTALL_PREFIX=$(pwd)/install && \
  cmake --build build && \
  cmake --install build && \
  cd build && \
  ctest --output-on-failure
)
./get_symbols.pl ./www/sionlib/install/lib* ./symbol_libversion.dat
(
  cd www/sionlib/ && \
  cmake -S test -B build-test -DSIONlib_ROOT=$(pwd)/install && \
  cmake --build build-test && \
  cd build-test && \
  ctest --output-on-failure
)
