#!/bin/bash

if [ $# -lt 3 ]; then
    echo "missing arguments"
    echo "usage: ${0##*/} MODE SOURCE DESTINATION"
    exit
fi

if [ ! -e $2 ]; then
    echo "$2 does not exist"
    exit
fi

if [ -d $3 ]; then
    OUT=$3/$(basename $2)
else
    OUT=$3
fi

if [ $1 == "mf" ]; then
    sed 's/\(SION_LIBNAME.*=.*\)\(sion\)/\1l\2/' $2 > $OUT
elif [ $1 == "cm" ]; then
    sed -e 's/\(SION_LIBNAME.* .*\)\(sion\)/\1l\2/' \
      -e 's/#SION_LIBVERSION_REP_H//' $2 > $OUT
elif [ $1 == "config" ]; then
    sed 's/-lsion/-llsion/' $2 > $OUT
elif [ $1 == "const" ]; then
    sed 's/SION_LVERSION_PREFIX ""/SION_LVERSION_PREFIX "L"/' $2 > $OUT
elif [ $1 == "test" ]; then
    sed 's/export SION/export LSION/;s/$SION_/$LSION_/' $2 > $OUT
    chmod a+x $OUT
else
    echo "unknown mode $1"
    exit 1
fi
