#!/usr/bin/perl

use strict;

my $patint="([\\+\\-\\d]+)";   # Pattern for Integer number
my $patfp ="([\\+\\-\\d.E]+)"; # Pattern for Floating Point number
my $patwrd="([\^\\s]+)";       # Pattern for Word (all noblank characters)
my $patbl ="\\s+";             # Pattern for blank space (variable length)

use File::Spec::Functions "catfile", "splitpath";

my $in="symbol_replacements.dat";
my $out="sion_libversion_rep.h";

my %replacements;
my ($line,$from,$to,$count);

open(REP,"$in");
while($line=<REP>) {
    if($line=~/^\s*$patint\:\s+$patwrd\s+\-\>\s+$patwrd/) {
	($from,$to)=($2,$3);
	$replacements{$from}=$to;
    }
}
close(REP);

open(OUT,"> $out");
print OUT "#ifndef SION_SION_LIB_REP_H\n";
print OUT "#define SION_SION_LIB_REP_H\n";
$count=0;
foreach $from (sort(keys(%replacements))) {
    if($from=~/^sion/) {
	print OUT "#define $from $replacements{$from}\n";
	$count++;
    }
}
print OUT "#endif\n";

close(OUT);
printf("%-50s (%d replacements)\n",$out,$count);
