#!/usr/bin/perl

use strict;
use warnings;

my $patint="([\\+\\-\\d]+)";   # Pattern for Integer number
my $patfp ="([\\+\\-\\d.E]+)"; # Pattern for Floating Point number
my $patwrd="([\^\\s]+)";       # Pattern for Word (all noblank characters)
my $patbl ="\\s+";             # Pattern for blank space (variable length)

use File::Spec::Functions "catfile", "splitpath";

my $replacemode=$ARGV[0]; # none, replace or internal
my $in=$ARGV[1];
my $out=$ARGV[2];

my ($line,$from,$to,$count);

my %replacements;

if($replacemode ne 'none') {
    my $replacefile="./symbol_replacements.dat";
    open(REP,"$replacefile");
    while($line=<REP>) {
        if($line=~/^\s*$patint\:\s+$patwrd\s+\-\>\s+$patwrd/) {
            ($from,$to)=($2,$3);
            $replacements{$from}=$to;
        }
    }
    close(REP);
}

if(-d $out) {
    my @path=splitpath($in);
    $out=catfile($out, $path[2]);
}

my $data;
$data="";

if(! -e $in) {
    printf("%s not found\n", $in);
    exit;
}
open(IN,$in);
if($replacemode eq 'none') {
    open(OUT,"> $out");
}
while($line=<IN>) {
    if($line=~/#NODIST#/) {
	$line=<IN>;
	while ($line!~/#NODIST#/) {
	    $line=<IN>;
	}
    } else {
        if($replacemode eq 'none') {
            print OUT $line;
        } else {
            $data.=$line;
        }
    }
}
close(IN);
if($replacemode eq 'none') {
    close(OUT);
} else {
    $count=0;
    foreach $from (keys(%replacements)) {
        if($replacemode eq 'internal') {
            next if($from=~/^sion/);
        }
        $to=$replacements{$from};
        $count+=($data=~s/(?<![a-zA-Z_])$from(?!\.h)(?![a-zA-Z_])/$to/gs);
    }

    $data=~s!\/\* DIST_INCLUDE_LIB_REP \*\/!#include \"sion_libversion_rep.h\"!gs;

    open(OUT,"> $out");
    print OUT $data;
    close(OUT);
    printf("%-50s (%d replacements)\n",$out,$count);
}
