#!/bin/bash

# This script replaces templates with new values for distribution. If
# the output is a folder the filename is used from the input file.

DIR=$(dirname "$0")
. "${DIR}/version.sh"

LIST=(
    "SION_VERSION = ${SION_VERSION}"
    "SION_DATE = ${SION_DATE}"
)

KEY_PATTERN=@@X@@

if [ $# -ne 2 ]; then
    echo "Missing file name"
    echo "Usage: ${0##*/} IN_FILE OUT_FILE_OR_FOLDER"
    exit
fi

IN_FILE="$1"
OUT_FILE="$2"
if [ -d "$OUT_FILE" ]; then
    OUT_FILE="${OUT_FILE%/}/${IN_FILE##*/}"
fi

SUBST=

# Looping with index is needed, because elements contain white spaces
for num in ${!LIST[*]}; do
    xx=${LIST[num]}
    key=${KEY_PATTERN/X/${xx/ = */}}
    val=${xx/* = /}
    SUBST+=s/$key/$val/g\;
done

sed "${SUBST}" "${IN_FILE}" > "${OUT_FILE}"
