#!/usr/bin/perl

my $patint="([\\+\\-\\d]+)";   # Pattern for Integer number
my $patfp ="([\\+\\-\\d.E]+)"; # Pattern for Floating Point number
my $patwrd="([\^\\s]+)";       # Pattern for Word (all noblank characters)
my $patbl ="\\s+";             # Pattern for blank space (variable length)

my($line,$sym,$l);
my(%symbols,%nonlibsymbols);

$dir=$ARGV[0];
$outfile=$ARGV[1];

open(IN,"nm $dir/*.a |");
while($line=<IN>) {
    if($line=~/$patwrd\s+[TdDb]\s+$patwrd\s*$/) {
	($sym)=($2);
	if(lc($sym)=~/lf?sion/) {
	    $symbols{$sym}++;
	} else {
	    $nonlibsymbols{$sym}++;
	}
    }
}
close(IN);

open(OUT,"> $outfile");

$l=0;
print OUT "Non-Lib Symbols:\n";
foreach $sym (sort(keys(%nonlibsymbols))) {
    printf(OUT "%3d: %-55s -> %s\n",++$l,$sym,$nonlibsymbols{$sym});
}

$l=0;
print OUT "\n";
print OUT "Lib Symbols:\n";
foreach $sym (sort(keys(%symbols))) {
    printf(OUT "%3d: %-55s -> %s\n",++$l,$sym,$symbols{$sym});
}

close(OUT);
