#!/usr/bin/perl

my $patint="([\\+\\-\\d]+)";   # Pattern for Integer number
my $patfp ="([\\+\\-\\d.E]+)"; # Pattern for Floating Point number
my $patwrd="([\^\\s]+)";       # Pattern for Word (all noblank characters)
my $patbl ="\\s+";             # Pattern for blank space (variable length)

my($line,$sym,$l);
my(%symbols);

$dir=$ARGV[0];
$outfile=$ARGV[1];

open(IN,"nm $dir/*.a |");
while($line=<IN>) {
    if($line=~/$patwrd\s+[TdDb]\s+$patwrd\s*$/) {
	($sym)=($2);
	$symbols{$sym}++;
    }
}
close(IN);

my($from,$to);
my(%replacement);
foreach $sym (sort(keys(%symbols))) {
#    print "$sym\n" if ($sym=~/f90/);
    
    if($sym=~/^__sion_f90(_|_mpi_|_omp_|_ompi_)MOD_(f[^\s]+)$/) {
	# fortran 90
	$from=$2;
	$to=$from;$to=~s/^fsion/lfsion/s;
	$replacement{$from}=$to;
#	print "F90: $sym $from -> $to\n";
    } elsif($sym=~/^(f[^\s]+)_/) {
	# fortran 77
	$from=$1;
	$to=$from;$to=~s/^fsion/lfsion/s;
	
	$replacement{$from}=$to;             # _FORTRANNOCAPS
	$replacement{uc($from)}=uc($to);     # _FORTRANCAPS
	$replacement{"${from}_"}="${to}_";   # _FORTRANUNDERSCORE
	$replacement{"${from}__"}="${to}__"; # _FORTRANDOUBLEUNDERSCORE
    } elsif($sym=~/^(_sion[^\s]+)/) {
	# C internal 
	$from=$1;
	$to=$from;$to=~s/^_sion/_lsion/s;
	$replacement{$from}=$to;
    } elsif($sym=~/^(sion[^\s]+)/) {
	# C public interface 
	$from=$1;
	$to=$from;$to=~s/^sion/lsion/s;
	$replacement{$from}=$to;
    } elsif($sym=~/^_Z/) {
	# C++ --> ignore
    } else {
	print "no replacement found: $sym\n";
    }
    
}

# for C++
$replacement{"SION_Base"}="LSION_Base";
$replacement{"SIONFile"}="LSIONFile";

open(OUT,"> $outfile");
$l=0;
foreach $sym (sort(keys(%replacement))) {
    printf(OUT "%3d: %-55s -> %s\n",++$l,$sym,$replacement{$sym});
}
close(OUT);
