#!/bin/bash
#
# Upload documentation to apps server

set -eu # exit on error or unset variables

DIR=$(dirname "$0")
. "${DIR}/version.sh"

HOST=apps.fz-juelich.de
SRC="${DIR}/../doc/html/"
DST="${HOST}:sionlib/sionlib/docu/${SION_VERSION}/"

if [ -e "${SRC}" ]; then
    cd "${SRC}"
    # for backward compatibility with GSB navigation
    ln -fs modules.html api_page.html
    ln -fs fileformat.html fileformat_page.html
    ln -fs util.html util_page.html
    ln -fs installation.html installation_page.html
    ln -fs release_notes.html release_notes_page.html
    cd -
    rsync -ahz --del "${SRC}" "${DST}"
else
    echo "ERROR: ${SRC} does not exist!"
fi
