#!/bin/bash

if [ -r /usr/local/module/modulecmd.tcl ]; then
    eval `tclsh /usr/local/module/modulecmd.tcl sh autoinit`
fi
if [ -d $HOME/.modules ]; then
 module use $HOME/.modules
fi


module load sionlib
module load zlib
module list

which sionconfig
set -x
make clean
make
SION_COLLSIZE=-1
export SION_COLLSIZE
export SION_DEBUG=siontestlog
mpiexec -np 4 -x SION_COLLSIZE -x SION_DEBUG --mca btl sm,self ./siontestgz
#exit

unset SION_DEBUG
sionsplit parfile_uc.sion test_1_uc.
sionsplit parfile_gz.sion test_1_gz.

mv test_1_gz.00000 test_1_gz.00000.gz
mv test_1_gz.00001 test_1_gz.00001.gz
mv test_1_gz.00002 test_1_gz.00002.gz
mv test_1_gz.00003 test_1_gz.00003.gz

#exit

GUNZIP="gunzip"
#GUNZIP="$HOME/releasetest/zlib/zlib-1.2.5/minigzip -d"

$GUNZIP test_1_gz.00000.gz
$GUNZIP test_1_gz.00001.gz
$GUNZIP test_1_gz.00002.gz
$GUNZIP test_1_gz.00003.gz

diff -q test_1_uc.00000 test_1_gz.00000
diff -q test_1_uc.00001 test_1_gz.00001
diff -q test_1_uc.00002 test_1_gz.00002
diff -q test_1_uc.00003 test_1_gz.00003
