/******************************************************************************\
*                                                                              *
*        Copyright (c) 2003, The Regents of the University of California       *
*      See the file COPYRIGHT for a complete copyright notice and license.     *
*                                                                              *
********************************************************************************
*
* CVS info:
*   $RCSfile: aiori-noSION.c,v $
*   $Revision: 1.2 $
*   $Date: 2008/12/02 17:12:14 $
*   $Author: rklundt $
*
* Purpose:
*       Empty SION functions for when compiling without SION support.
*
\******************************************************************************/

#include "aiori.h"

void *
IOR_Create_SION(char        * testFileName,
                 IOR_param_t * param)
{
    ERR("This copy of IOR was not compiled with SION support");
    return 0;
}

void *
IOR_Open_SION(char        * testFileName,
               IOR_param_t * param)
{
    ERR("This copy of IOR was not compiled with SION support");
    return 0;
}


IOR_offset_t
IOR_Xfer_SION(int            access,
               void         * fd,
               IOR_size_t   * buffer,
               IOR_offset_t   length,
               IOR_param_t  * param)
{
    ERR("This copy of IOR was not compiled with SION support");
    return 0;
}

void
IOR_Fsync_SION(void * fd, IOR_param_t * param)
{
    ERR("This copy of IOR was not compiled with SION support");
}

void
IOR_Close_SION(void        * fd,
                IOR_param_t * param)
{
    ERR("This copy of IOR was not compiled with SION support");
}

void
IOR_Delete_SION(char * testFileName, IOR_param_t * param)
{
    ERR("This copy of IOR was not compiled with SION support");
}

void
IOR_SetVersion_SION(IOR_param_t *test)
{
    ERR("This copy of IOR was not compiled with SION support");
}

IOR_offset_t
IOR_GetFileSize_SION(IOR_param_t * test,
                      MPI_Comm   testComm,
                      char     * testFileName)
{
    ERR("This copy of IOR was not compiled with SION support");
    return 0;
}
