      program res_dilute_new

        integer, parameter :: real_4   = selected_real_kind(6)
        integer, parameter :: real_8   = selected_real_kind(13)
        real*8, dimension(3)  ::  x, v, box, box_new
        real*8, dimension(:,:), allocatable  ::  rxyz, vxyz
        integer, dimension(3) ::  scale
        integer, dimension(:), allocatable ::  idx_vec, idx_mol, idx
        real*8                              ::  fib_rnd
        real*8                              ::  conc, conc_org
        real (kind = real_8), save          ::  seed = 1.0
        character (len=80)                  ::  comment
        character (len=4), dimension(4), parameter    ::  name = (/" O  "," N  "," S  "," Br " /)

        open(unit=87,file="mp2c_slt.xyz",status="unknown")
        open(unit=88,file="mp2c_slt.res_out",status="unknown")
        open(unit=89,file="mp2c_slt.res",status="unknown")
        k = 0

        open( unit=99, file = "res_dilute_new.inp" )
        print*," how many old molecules? "
        read(99,"(a)") comment
        read(99,*) n_mol_old
        print*," how many new molecules? "
        read(99,"(a)") comment
        read(99,*) n_mol_new
        print*," how many monomers in a molecule? "
        read(99,"(a)") comment
        read(99,*) n_sites

print*," no. old molecules: ",n_mol_old
print*," no. new molecules: ",n_mol_new
print*," no. of sites:      ",n_sites

        allocate( idx(n_mol_old*n_sites) )
        idx = 0

        allocate( idx_mol(n_mol_old) )
        idx_mol = 0

        n = 0
        do 
           i = 1 + fib_rnd(seed)*( n_mol_old - 1 )
           if( idx_mol(i) /= 1 )then
              idx_mol(i) = 1
              n = n+1
!print*," n = ",n
           endif

           if( n == n_mol_new ) exit

        enddo


        open(unit=99,file="res_dilute_new.idx")
        n = 0
        ij = 0
        do i = 1, n_mol_old
           do j = 1, n_sites

              n = n+1
              if( idx_mol(i) == 1 )then
                 ij = ij+1
                 idx(n) = ij
              endif
              write(99,"(2i10)") n,idx(n)
           enddo
        enddo
        close(99)

        stop









        print*," which concentration? "
        read(99,"(a)") comment
        read(99,*) conc
        print*," which box sizes?"
        read(99,"(a)") comment
        read(99,*) box(1:3)

        read(89,*) n_part, k
        allocate( idx_vec(n_part) )
        idx_vec = 0

        conc_org = real(n_part) / (box(1)*box(2)*box(3) )

        n_red = nint((conc / conc_org) * real(n_mol) )
        print*," number of molecules in redu ed system: ",n_red

        ij = 0
        do i = 1, n_red
           do 
              j = 1 + nint( (n_mol-1)*fib_rnd(seed) )
              if( idx_vec(j) == 0 )then
                 idx_vec(j) = 1
                 exit
              endif
           enddo
        enddo

        n_mon = n_part / n_mol

        allocate( rxyz(3,n_part) )
        allocate( vxyz(3,n_part) )

        do i = 1, n_part
           read(89,*) m,x(1:3),v(1:3)
           do k = 1, 3
              rxyz(k,m) = x(k)
              vxyz(k,m) = v(k)
           enddo
        enddo
        close(89)

        open(unit=99,file="polymer.xyz")
        write(99,"(i6,/,a)") n_red * n_mon," polymer chain system"
        write(88,"(3i9)") n_red * n_mon,0,512

        ij = 0
        do i = 1, n_mol
           im = modulo(i,4) + 1
           if( idx_vec(i) == 1 )then
              is = (i-1)*n_mon
!!$              write(99,"(a4,3es14.5)") " O ",rxyz(1:3,is)
              do j = is+1, is+n_mon
                 ij = ij+1
                 write(99,"(a4,3es14.5)") name(im), rxyz(1:3,j)
                 write(88,"(i9,6es18.9)") ij, rxyz(1:3,j), vxyz(1:3,j)
              enddo
           endif
        enddo

        close(99)


        close(87)
        close(88)

      end program res_dilute_new



        function rnd(seed)             result( rand )
          integer, parameter :: real_4   = selected_real_kind(6)
          integer, parameter :: real_8   = selected_real_kind(13)
          real (kind = real_8), parameter ::  d2p31m = 2147483647.0 ,        &
               d2p31  = 2147483648.0
          real (kind = real_8), intent(inout) ::  seed
          real (kind = real_8)                ::  rand
          rand = real( seed / d2p31 , real_4 )
          seed = modulo( 16807.0_real_8 * seed , d2p31m )
        end function rnd

        function fib_rnd(seed)         result(rand)
          integer, parameter :: real_4   = selected_real_kind(6)
          integer, parameter :: real_8   = selected_real_kind(13)
          real (kind = real_8), intent(inout)       ::  seed
          real (kind = real_8)                      ::  rand, rnd
          integer, save                             ::  i_ctrl = 0
          integer, save                             ::  i=17, j=5, k
          real (kind = real_8), dimension(17), save ::  x
          if( i_ctrl == 0 )then
             do k = 1,17
                x(k) = rnd(seed)
             enddo
             i_ctrl = 1
          endif
          rand = x(i) - x(j)
          if( rand < 0.0 ) rand = rand+1.0
          x(i) = rand
          i = i-1
          if( i == 0 ) i = 17
          j = j-1
          if( j == 0 ) j = 17
        end function fib_rnd
