/****************************************************************************
**  SIONLIB     http://www.fz-juelich.de/jsc/sionlib                       **
*****************************************************************************
**  Copyright (c) 2008-2009                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <mpi.h>
#include <time.h>
#include <math.h>

#include "sion.h"

#define FNAMELEN 255
#define BUFSIZE (1024*1024)

int main(int argc, char **argv)
{

  int       rank, size;
  char          fname[FNAMELEN];
  int           numFiles;
  MPI_Comm      *lComm;
  sion_int64    chunksize;
  sion_int32    fsblksize;
  int           globalrank;
  FILE         *fileptr;
  char          *newfname;
  int           sid;
  size_t        btoread, bread;
  char          *localbuffer;

  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &size);
  MPI_Comm_rank(MPI_COMM_WORLD, &rank);

  localbuffer = (char *) malloc(BUFSIZE);

  strcpy(fname, "partest_parfile.sion");
  sid=sion_paropen_mpi(fname,"br",&numFiles,MPI_COMM_WORLD,&lComm,&chunksize,&fsblksize, &globalrank, &fileptr, &newfname);
  
  while((!sion_feof(sid))) { 
    btoread=sion_bytes_avail_in_block(sid);         
    bread=fread(localbuffer,1,btoread,fileptr);     
  }             
  
  sion_parclose_mpi(sid);  

  MPI_Finalize();

  return (0);
}
