/****************************************************************************
**  SIONLIB     http://www.fz-juelich.de/jsc/sionlib                       **
*****************************************************************************
**  Copyright (c) 2008-2021                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef SION_SION_KEYVALUE_H
#define SION_SION_KEYVALUE_H

/// \cond sion_internal
/// \file

#include <stddef.h>
#include <stdint.h>

#include "sion_enums.h"
#include "sion_filedesc.h"

int _sion_keyval_check_env(_sion_filedesc *sion_filedesc, int64_t file_mode_flags);
int _sion_keyval_check_env_with_options(_sion_filedesc *sion_filedesc, sion_open_mode open_mode, sion_keyval_mode keyval_mode);
int _sion_keyval_dup_dataptr(_sion_filedesc *sion_filedesc, _sion_filedesc *new_filedesc);

int _sion_store_and_write_key_and_len(_sion_filedesc *sion_filedesc, uint64_t key, size_t len);
int _sion_write_value(_sion_filedesc *sion_filedesc, const void *data, uint64_t key, size_t len);

int _sion_find_and_read_key_and_len(_sion_filedesc *sion_filedesc, uint64_t key, size_t len, size_t *datalen);
int _sion_read_value(_sion_filedesc *sion_filedesc, void *data, uint64_t key, size_t len);

/// \endcond

#endif
