# -*- python -*-
#
#  SIONLIB     http://www.fz-juelich.de/jsc/sionlib
#
#  Copyright (c) 2014-2021
#  Forschungszentrum Juelich, Juelich Supercomputing Centre
#
#  See the file COPYRIGHT in the package base directory for details
#
from libc.stdio cimport FILE
from libc.stdint cimport int32_t, uint32_t, int64_t, uint64_t
from mpi4py.libmpi cimport MPI_Comm

cdef extern from "sion.h":
    int sion_open(char *fname,
                  const char* file_mode,
                  int  *ntasks,
                  int  *nfiles,
                  int64_t **chunksizes,
                  int32_t  *fsblksize,
                  int  **globalranks,
                  FILE **fileptr)

    int sion_close(int sid)

    size_t sion_fwrite(const void *data,
                       size_t size,
                       size_t nitems,
                       int sid)

    size_t sion_fread(void *ptr,
                      size_t size,
                      size_t nmemb,
                      int sid)

    int64_t sion_bytes_avail_in_chunk(int sid)

    size_t sion_fwrite_key(const void *data,
                           uint64_t key,
                           size_t size,
                           size_t nitems,
                           int sid)

    size_t sion_fread_key(void *data,
                          uint64_t key,
                          size_t size,
                          size_t nitems,
                          int sid)

cdef extern from "sion_mpi.h":
    int sion_paropen_mpi(char *fname,
                         const char *file_mode,
                         int *numFiles,
                         MPI_Comm gComm,
                         MPI_Comm *lComm,
                         int64_t *chunksize,
                         int32_t *fsblksize,
                         int *globalrank,
                         FILE **fileptr,
                         char **newfname)

    int sion_parclose_mpi(int sid)
    int sion_parreinit_mpi(int sid,
                           int64_t chunksize)
