!/****************************************************************************
!**  SIONLIB     http://www.fz-juelich.de/jsc/sionlib                       **
!*****************************************************************************
!**  Copyright (c) 2008-2021                                                **
!**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
!**                                                                         **
!**  See the file COPYRIGHT in the package base directory for details       **
!****************************************************************************/
program main
  implicit none

  include 'mpif.h'
  integer ierr, size, rank, i
  character(len=255) :: filename = 'test_sionfile.sion'
  character(len=255) :: newfname
  integer :: nfiles
  integer :: gComm,lComm,sid,globalrank
  integer :: fsblksize
  integer*8 :: chunksize
  real*8 :: sum,buffer(1000)
  integer :: fileno

  call MPI_INIT(ierr)
  call MPI_COMM_SIZE(MPI_COMM_WORLD, size, ierr)
  call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)

  ! step 1
  gcomm=MPI_COMM_WORLD
  globalrank=rank
  fsblksize=1000000
  chunksize=2000000
  nfiles=1
  call fsion_paropen_mpi(trim(filename),'bw',nfiles, gComm,lComm,chunksize,fsblksize,globalrank,newfname,sid)

  call fsion_get_fileno(sid,fileno)

  buffer=1111.011

  write (6,*) 'on rank ',rank,': unit=',fileno
  write(unit=fileno) buffer

  call fsion_parclose_mpi(sid,ierr)

  globalrank=-1
  fsblksize=-1
  chunksize=-1
  lcomm=-1

  call fsion_paropen_mpi(trim(filename),'br',nfiles, gComm,lComm,chunksize,fsblksize,globalrank,newfname,sid)

  buffer=0
  call fsion_read(buffer,8,1000,sid,ierr)
  if(rank .eq. 0) then
     write (6,*) 'on rank ',rank,': read=',ierr
     do i=0,1000
        sum=sum+buffer(i)
     end do
     write (6,*) 'on rank ',rank,': sum=',sum
  end if

  call fsion_parclose_mpi(sid,ierr)
  if(rank .eq. 0) then
     write (6,*) 'on rank ',rank,': nfiles=',nfiles
     write (6,*) 'on rank ',rank,': chunksize=',chunksize
     write (6,*) 'on rank ',rank,': fsblksize=',fsblksize
  end if
  call MPI_Finalize(ierr)
!  stop
end program main
