#!/bin/bash

WIDTH=200
BACKGROUND=
INNAME=sionlib_logo.svg

while getopts :w:b OPT; do
    case $OPT in
        w|+w)
            WIDTH="$OPTARG"
            ;;
        b|+b)
            BACKGROUND="--export-background=white"
            ;;
        *)
            echo "usage: ${0##*/} [+-w ARG] [+-b} [--] ARGS..."
            exit 2
    esac
done
shift $(( OPTIND - 1 ))
OPTIND=1

OUTNAME=sionlib_logo_${WIDTH}.png

inkscape \
    $BACKGROUND \
    --export-width=$WIDTH \
    --export-png=$OUTNAME \
    $INNAME
